﻿using System.ServiceModel;
using System.Windows.Input;
using Vertrag;
using HilfeTools;
using System.Threading;
using System.Net;
using System.Windows;
using System;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;
using Microsoft.VisualBasic;

//Viewmodel
namespace Client.Viewmodel
{
    public partial class MainModel : Model
    {
        private IvertragAsynchron objProxy;

        #region Properties für Knöpfe
       
        private Cbefehl _SkalaStart;
        public ICommand SkalaStart
        {
            get { return (_SkalaStart ?? (_SkalaStart = new Cbefehl(Start))); }
            //Der Operator ?? wird NULL-Sammeloperator genannt. 
            //Der linke Operand wird zurückgegeben, falls dieser NICHT NULL ist. 
            //Andernfalls wird der rechte Operand zurückgegeben.
        }

        private Cbefehl _Speichern;
        public ICommand Speichern
        {
            get { return (_Speichern ?? (_Speichern = new Cbefehl(OnSpeichern))); }
        }

        private Cbefehl _Laden;
        public ICommand Laden
        {
            get { return (_Laden ?? (_Laden = new Cbefehl(OnLaden))); }
        }

      
        #endregion

        public void OnSpeichern()
        {
            Microsoft.Win32.SaveFileDialog dialog = new Microsoft.Win32.SaveFileDialog();
            dialog.Filter = "Txt-Files(*.txt)|*.txt";

            Nullable<bool> result = dialog.ShowDialog();
            if (result == true)
            {
                File.WriteAllText(dialog.FileName, IpAddress + "\r\n"
                                                + PortNumber + "\r\n");                        
            }   
        }

        public void OnLaden()
        {
            Microsoft.Win32.OpenFileDialog dialogo = new Microsoft.Win32.OpenFileDialog();
            dialogo.Filter = "Txt-Files(*.txt)|*.txt";

            Nullable<bool> result = dialogo.ShowDialog();
            if (result == true)
            {
                IpAddress = File.ReadAllLines(dialogo.FileName)[0].ToString();
                PortNumber = File.ReadAllLines(dialogo.FileName)[1].ToString();      
            }          
        }

        public void Start()
        {           
            try
            {                
                 string rmAddres = null;
                 rmAddres = "net.tcp://" + IpAddress + ":" + PortNumber + "/IvertragAsynchron";
                 // rmAddres = "net.tcp://" + "10.202.4.128" + ":" + "2121" + "/IvertragAsynchron";

                 NetTcpBinding nettcpbinding = new NetTcpBinding(SecurityMode.None); // new NetTcpBinding(hier MUSS was stehen!! sonst tuts ned) 
                 ChannelFactory<IvertragAsynchron> chFactory = new ChannelFactory<IvertragAsynchron>(nettcpbinding);
                 nettcpbinding.MaxReceivedMessageSize = 10485760; // 10485760 entspricht 10 MB

                 TimeSpan mSpan = default(TimeSpan);
                 mSpan = new TimeSpan(1200000000); // entspricht 2 Minuten (1 Millisekunde = 10.000 Ticks) -> 2min = 120.000ms = 1.200.000.000Ticks
                 nettcpbinding.SendTimeout = mSpan;

                 EndpointAddress epAddress = new EndpointAddress(rmAddres);
                 objProxy = chFactory.CreateChannel(epAddress);

                 this.StringContent = "Anfrage läuft...währenddessen kann das Fenster frei bewegt werden";

                 if (objProxy.Ping())
                 {
                     objProxy.BeginDoIt( asyncResult =>
                     {
                         this.StringContent  = objProxy.EndDoIt(asyncResult).Content; 
                     }, null); // Mitgabe von Informationen (hier aus den Textboxen auf der View des Clients)
                 }
            }
            catch (Exception ex)
            {                
                this.StringContent = ex.Message; //gibt Fehlermeldung aus
            }
        }
    }
}